/*
 * $Id: Common.h,v 1.2 2002/09/01 23:33:57 ben Exp $
 * common.h -- thom, 13 jun 2001
 *
 *    Common types & definitions.
 *
 */
#ifndef COMMON_H
#define COMMON_H

#include "ace/OS.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Connector.h"
#include <string>


// Types
typedef ACE_UINT64 ulong64;
typedef ACE_INT32 int32;
typedef ACE_UINT32 uint32;
typedef ACE_INT16 short16;
typedef ACE_UINT16 ushort16;
#define UINT32_MAX 4294967295U

// namespaces
using namespace std;

// Default ports and timeouts
#define DEFAULT_TIMEOUT 4
extern ACE_Time_Value DEFAULT_TIME_VALUE;  
#define DEFAULT_SEARCH_THREADS 1
#define DEFAULT_PROPAGATE_THREADS 1

// tchar typedefs
typedef char tchar;
typedef std::string tstring;
#define t_strcpy strcpy
#define t_strcmp strcmp
#define t_strlen strlen
#define t_strcat strcat

// max and min
#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

#define SKY_EXPORT

#endif
