
#include "Game.h"
#include "Random.h"
#include <iostream>
#include <iomanip>

template class Matrix<char>;

unsigned Player::_bagsize = 0;
unsigned Player::_id = 0;

Game::Game(Matrix<char>& board, unsigned my_id, unsigned weight, unsigned
    dollars, const Point& size) 
: _board(board,my_id,*this), 
  _gstrategy(*this), _mstrategy(*this), _stats(board._size,*this),
  _distances(_board), _ttime(_board)
{
  _me._bagsize = weight;
  _me._id = my_id;

  _me._dollars = dollars;
  _me._points = 0;
//  seed_rand();
}

void
Game::place_robot(unsigned id, Point pos)
{
  _board.place_robot(id, pos);
  if (id == _me._id) _me._position = pos;
}

MyMove
Game::get_move()
{
  static bool justPicked = false;

  // erase all robots you haven't seen in a turn
  if (_deadRobots.size() > 0) {
    _board.erase_robots(_deadRobots);
  }
  
  // now eliminate them and reset the list
  _deadRobots = _robots;
  _robots.clear();

  _stats.log_robot_positions();
  _stats.calculate_resistances();
  
  if (!justPicked)
    _gstrategy.get_goal(); // sets _cached_goal and _packages_goal
  MyMove mm = _mstrategy.get_move();
  _me._dollars -= mm._dollars;

  if (_standingOn.size() > 0 && (mm._command == DROP || mm._command == PICK))
    justPicked = true;
  else
    justPicked = false;

  if (mm._command == DROP) {
    for (list<unsigned>::iterator i = mm._items.begin();
	i != mm._items.end(); i++) {
      _stats.score(_packages[*i]._weight);
    }
  }
  if (_standingOn.size() == 0)
  {
    _board.erase_homebase(_me._position);
  }

  return mm;
}

void
Game::update(GameMove &gm)
{
  // Set that you have seen this robot
  _robots.remove(gm._robot_id);
  _robots.push_front(gm._robot_id);
  _deadRobots.remove(gm._robot_id);
  
  _board.update(gm);
  // TODO add tracking of other robot's packages
  list<unsigned>::iterator i;
  
  if (gm._robot_id == _me._id) {
    if (gm._command == PICK) {
      
      for (i = gm._items.begin(); i != gm._items.end(); i++) {
	_me._carrying.push_back(*i);
      }
    
    } else if (gm._command == DROP) {
      
      for (i = gm._items.begin(); i != gm._items.end(); i++) {
	_me._carrying.remove(*i);
      }

    } else {
      _me._position = _board.get_position(_me._id);
    }
  }
}

void
Game::set_packages(list<unsigned>& packages)
{
  _standingOn = packages;
}

void
Game::set_package_specs(unsigned id, Point p, unsigned weight)
{
  _packages[id] = BaggedPackage(id,p,weight);
}


void
Game::print_board(ostream& out) {
  // print the board for the world to see
  unsigned i,j;
  unsigned x = _board.size().x;
  unsigned y = _board.size().y;
  for (i = y; i > 0; i--) {
    for (j = 0; j < x; j++) {
      if (Point(j,i-1) == _me._position) {
	out << "F";
      } else if (_board._robotPos.findp(Point(j,i-1))) {
	out << "r";
      } else {
	out << _board._board.char_at(j,i-1);
      }
    }
    out << endl;
  }
  /*
  int midx = max(min(int(x-4),int(_me._position.x)),5);
  int midy = max(min(int(y-4),int(_me._position.y)),5);
  for (i = midy+4; i > midy-4; i--) {
    for (j = midx-4; j < midx+4; j++) {
      Point p(j,i);
      out << setw(5) << _stats.robot_visits->at(p);
    }
    out << endl;
  }
  */
}

unsigned
Game::new_homebase_points()
{
  return (_board.size().x + _board.size().y) / 8 * 100;
}
