/*
 * @(#) $Id: Random.h,v 1.1 2002/09/01 23:33:57 ben Exp $
 * simple implementation of a random number generator from numerical receipts
 */

#ifndef RANDOM_SKY_H_
#define RANDOM_SKY_H_

#include <sys/types.h>
#include <unistd.h>
#include <time.h>

void seed_rand();
void seed_rand(int n);
u_int rand_int(u_int max);
double rand_double();


// seeding the randon number generator
void sran1(int);

/* function:    ran1
 * description: returns a uniform random deviate between 0.0 and 1.0
 *              should not be used when number of calles exceed 10^8
 */
double ran1(void);



/* function:    gasdev
 * description: returns random numbers with a gaussian distribution with
 *              0 mean and unit variance, using ran1() as the source of
 *              uniform deviate.
 */
double gasdev(void);

class RandomGenerator {
    public:
	void sran1(int);
	double ran1(void);
	double gasdev(void);
    private:
	long _ran_seed;
};

#endif
