
#ifndef ROBOT_H
#define ROBOT_H

#include "Types.h"
class Game;

class Robot
{
  public:
    Robot(); // DONT USE!
    Robot(Game&, unsigned id, const Point& p, bool dummy=false);
    Robot(const Robot&);
    Robot& operator=(const Robot&);
    ~Robot();
    unsigned _id;
    list<unsigned> _packages;
    Matrix<int> *_distances;
    Point _position;

    void set_position(const Point& p);
    const Point& position();
    void move(COMMAND c);
    int get_distance_to(const Point& p);

  private:
    Game *_game;
    Point _cached;
    bool _dummy;

    void calculate_distances();
};

#endif
