#include "SockStream.h"

ACE_Time_Value tenms(60,0);

SockStream::SockStream(const SockStream& ss) {
    *this = ss;
}

SockStream::SockStream(const ACE_Time_Value* timeout)
{
    m_sock.set_handle(ACE_INVALID_HANDLE);
    set_timeout(timeout);
}

SockStream::SockStream(ACE_SOCK_Stream &sock, const ACE_Time_Value* timeout)
{
    m_sock = sock;
    set_timeout(timeout?timeout:&tenms);
}

SockStream::SockStream(ACE_HANDLE &h, const ACE_Time_Value* timeout)
{
    m_sock.set_handle(h);
    set_timeout(timeout?timeout:&tenms);
}

int
SockStream::writeBuffer(void* buf, int nLen)
{
    int r = m_sock.send(buf, nLen, m_pTimeout);
    return r;
}

int
SockStream::readBuffer(void* buf, int nLen)
{
    int r = m_sock.recv(buf, nLen, m_pTimeout);
    return r;
}

void
SockStream::close() {
    m_sock.close();
}

void
SockStream::set_timeout(const ACE_Time_Value* tv) {
    if (tv == NULL) {
        m_pTimeout = NULL;
    } else {
        m_timeout = *tv;
        m_pTimeout = &m_timeout;
    }


}

ACE_Time_Value*
SockStream::get_timeout() const {
    return m_pTimeout;
}

void
SockStream::set_handle(ACE_HANDLE h)
{ m_sock.set_handle(h); }

ACE_HANDLE
SockStream::get_handle() const
{ return m_sock.get_handle(); }
SockStream::~SockStream ()
{
}

SockStream&
SockStream::operator=(const SockStream& s) {
    m_sock = s.m_sock;
    set_timeout(s.get_timeout());
    return *this;
}

void 
SockStream::set(ACE_SOCK_Stream &sock) {
    m_sock = sock;
}
