#ifndef SOCKSTREAM_H
#define SOCKSTREAM_H

#include "ace/SOCK_Stream.h"
#include "ace/Time_Value.h"
#include "Serial.h"

class Connector;

class SockStream : public DataStream {
  private:
    ACE_SOCK_Stream m_sock;
    ACE_Time_Value *m_pTimeout;
    ACE_Time_Value m_timeout;

  public:
    SockStream(ACE_SOCK_Stream &sock, const ACE_Time_Value* timeout = NULL);
    SockStream(ACE_HANDLE &handle, const ACE_Time_Value* timeout = NULL);
    SockStream(const ACE_Time_Value* timeout = NULL);
    SockStream(const SockStream&);


    virtual ~SockStream();

    // returns the number of bytes written/read
    virtual int writeBuffer(void* buf, int len);
    virtual int readBuffer(void* buf, int len);
    void close();


    SockStream& operator=(const SockStream&);

    void set(ACE_SOCK_Stream &sock);
    void set_handle(ACE_HANDLE h);
    ACE_HANDLE get_handle() const;


    // these function define the timeout
    ACE_Time_Value *get_timeout() const;
    void set_timeout(const ACE_Time_Value*);

	friend Connector;
};


#endif
