#ifndef STATS_H
#define STATS_H

#include "bighashmap.hh"
#include "Types.h"

class Game;

class Stats
{
  private:
    // counters
    int moves;
    int points;
    double _mult, _wallmult, _watermult;
    Game& _game;
//    BigHashMap<unsigned, unsigned> _packageMap; 

  public:
    Matrix<unsigned short> *robot_visits;
    Matrix<unsigned> *resistance;

    Stats(Point& size, Game& game);

    void log_robot_positions();
    void calculate_resistances();
    unsigned get_res_at(const Point &);
    void score(int score);

    unsigned points_per_hundred_dollars();

  private:
    unsigned get_resistance(unsigned,unsigned,unsigned);
    double mult_at(unsigned,unsigned);
    void set_mults(unsigned);

    
    /*
    unsigned package_weight(unsigned id); // returns average if unknown
    unsigned average_package_weight();
    unsigned points_per_hundred_dollars();
    unsigned points_per_move();
    unsigned dollars_per_move();
    unsigned points();
    unsigned average_time();

    void move(unsigned dollars, unsigned points, unsigned heuristic, 
	int elapsed);
    void new_package(unsigned id, unsigned weight);
    */
};

#endif
