#ifndef TRAVEL_TIME_H
#define TRAVEL_TIME_H

#include "Types.h"
#include "Stats.h"
class Board;
class Point;

// for travel time estimates
class TravelTime
{
  private:
    Matrix<int> _distances;
    Matrix<char> _directions;

    unsigned _x,_y;
    Point _size;
    const Board &_board;
    Stats *_stats;

  public:
    TravelTime(const Board& size); // makes a square this big
    ~TravelTime();

    // these three go together
    void load_distances(const Point&); // djykstra's
    int get_distance_to(const Point&);
    int get_direction_for(const Point&);
    int get_distance_between(const Point&,const Point&);

  private:
    void insert(list<Point>& Q, Point p);
};

#endif
